#include <GDIPlus.au3>
#include <WindowsConstants.au3>
#include <GUIConstantsEx.au3>



Dim $ws[12] = [0, 0, 10, -7, 50, -7, 60, 0, 50, 7, 10, 7]  ;Koordinaten Polygonzug: von links nach rechts WAAGRECHTER Balken, von rechts nach links SENKRECHTER Balken
Dim $ziffer[10] = [239, 10, 118, 94, 154, 220, 253, 14, 254, 222] ;alle gesetzten bits des Indexes in der 7-segmentanzeige ergeben die Ziffer
Dim $balkenpos[8] = [0, "60.0", "0.0", "60.60", "0.60", "0.60", "0.120", "0.0"] ;position der Leuchtbalken der 7-Segmentanzeige innerhalb der Ziffer
Dim $p[7][2]                                               ;nimmt die polygonzug-koordinaten zum Zeichnen auf
$p[0][0] = 6                                               ;6 Punkte im Polygonzug



_GDIPlus_Startup()



Global $hgui = GUICreate('Uhr', 620, 175, -1, -1, $WS_POPUP) ;GUI erstellen ohne Rahmen
Global $hWnd = WinGetHandle($hgui)                         ;Handle holen
Global $hGraphic = _GDIPlus_GraphicsCreateFromHWND($hWnd)  ;"Leinwand" erstellen, auf der gezeichnet werden kann
GUICtrlCreateLabel("", 0, 0, 620, 175, Default, $GUI_WS_EX_PARENTDRAG) ;verschieben des Fensters möglich machen durch 2. Fenster
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)            ;das 2. Fenster transparent machen
GUISetBkColor(0x000000)                                    ;Hintergrund der GUI schwarz
GUISetState()                                              ;GUI anzeigen
AdlibRegister("_time", 1000)                               ;jede Zehntelsekunde ein Refresh der Zeitanzeige
Do                                                         ;Endlosschleife, solange bis..
Until GUIGetMsg() = -3                                     ;..ESC gedrückt wird
_GDIPlus_GraphicsDispose($hGraphic)                        ;freigeben
_GDIPlus_Shutdown()



Func _time()                                               ;Uhrzeit anzeigen :o)
    For $k = 1 To 6                                        ;die 6 Ziffern der Uhrzeit
        $setbits = $ziffer[StringMid(String(@HOUR & @MIN & @SEC), $k, 1)] ;gesetzte Bits in der siebensegmentanzeige anhand der Ziffer in der Uhrzeit holen
        For $bitnr = 7 To 1 Step -1                        ;alle Bits durchlaufen
            _drawpolygon(BitAND($setbits, 128), $k * 100 - 80 + ($k = 1 Or $k = 3 Or $k = 5) * 20, $bitnr) ;parameter: bit gesetzt ja/nein, position der gesamten ziffer,nummer des bits(gerade=waagrechter balken, ungerade=senkrechter balken)
            $setbits = BitShift($setbits, -1)              ;nächstes Bit holen
        Next
    Next
    $brush = _GDIPlus_BrushCreateSolid(0xFF440000 + (@SEC / 2 = Int(@SEC / 2)) * 0xBB0000) ;Pinsel erstellen, wenn Ziffer gerade, dann farbig, ansonsten schwarz
    _GDIPlus_GraphicsFillEllipse($hGraphic, 202, 55, 15, 15, $brush) ;Punkte zeichnen
    _GDIPlus_GraphicsFillEllipse($hGraphic, 402, 55, 15, 15, $brush)
    _GDIPlus_GraphicsFillEllipse($hGraphic, 202, 105, 15, 15, $brush)
    _GDIPlus_GraphicsFillEllipse($hGraphic, 402, 105, 15, 15, $brush)
    _GDIPlus_BrushDispose($brush)                          ;Pinsel auflösen
EndFunc                                                    ;==>_time



Func _drawpolygon($bit, $xpos, $bitnr)                     ;zeichnet einen polygonzug ("Balken") an die entsprechende Position
    $split = StringSplit($balkenpos[$bitnr], ".", 3)       ;x- und y-koordinaten des Balkens innerhalb der Ziffer holen
    $b = (($bitnr / 2) = Int($bitnr / 2))                  ;$bit gerade => $b = true => Balken waagrecht, ansonsten Balken senkrecht
    $step = -1 + 2 * $b                                    ;schrittweite durch das $WS-Array
    For $i = 11 - 11 * $b To 11 * $b Step 2 * $step        ;array mit waagrechten (bit=gerade) oder (Bit=ungerade) senkrechten Balken füllen
        $r = Int(Abs((11 * (Not ($b))) - $i) / 2) + 1      ;abhängig von der Reihenfolge, egal ob $i von 0 bis 11 oder von 11 bis 0, $r muss immer 1,2,3,4,5,6
        $p[$r][0] = $ws[$i] + $split[0] + $xpos            ;x- und
        $p[$r][1] = $ws[$i + $step] + $split[1] + 30       ;y-position in das polygonarray schreiben
    Next
    $brush = _GDIPlus_BrushCreateSolid(0xFF440000 + ($bit <> 0) * 0xBB0000) ;wenn bit gesetzt, dann farbig, ansonsten schwarz
    _GDIPlus_GraphicsFillPolygon($hGraphic, $p, $brush)    ;Balken zeichnen
    _GDIPlus_BrushDispose($brush)
EndFunc                                                    ;==>_drawpolygon

